using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;
using Microsoft.Win32;
using System.Management;

namespace TestServiceWithMessageLoop
{
	public class Service1 : System.ServiceProcess.ServiceBase
	{
		private WindowsMessageLoopThread _thread = null;
		
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Service1()
		{
			// This call is required by the Windows.Forms Component Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitComponent call
		}

		// The main entry point for the process
		static void Main()
		{
			System.ServiceProcess.ServiceBase[] ServicesToRun;
	
			// More than one user Service may run within the same process. To add
			// another service to this process, change the following line to
			// create a second service object. For example,
			//
			//   ServicesToRun = new System.ServiceProcess.ServiceBase[] {new Service1(), new MySecondUserService()};
			//
			ServicesToRun = new System.ServiceProcess.ServiceBase[] { new Service1() };

			System.ServiceProcess.ServiceBase.Run(ServicesToRun);
		}

		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			components = new System.ComponentModel.Container();
			this.ServiceName = "Service1";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// Set things in motion so your service can do its work.
		/// </summary>
		protected override void OnStart(string[] args)
		{
			StartNotifyIconThread();

			// we do this with the session events so that the system tray icon survives the user logging off & logging on again
			Microsoft.Win32.SystemEvents.SessionEnding += new SessionEndingEventHandler(SystemEvents_SessionEnding);
			Microsoft.Win32.SystemEvents.SessionEnded += new SessionEndedEventHandler(SystemEvents_SessionEnded);
		}
 
		/// <summary>
		/// Stop this service.
		/// </summary>
		protected override void OnStop()
		{
			ShutdownNotifyIconThread();
		}

		private void SystemEvents_SessionEnded(object sender, SessionEndedEventArgs e)
		{
			StartNotifyIconThread();
		}

		private void SystemEvents_SessionEnding(object sender, SessionEndingEventArgs e)
		{
			ShutdownNotifyIconThread();
		}

		private void ShutdownNotifyIconThread()
		{
			if (_thread != null)
			{
				_thread.Stop();
				_thread = null;
			}
		}

		private void StartNotifyIconThread()
		{
			if (_thread == null)
			{
				_thread = new WindowsMessageLoopThread();
			}
		}
	}

	[RunInstallerAttribute(true)]
	public class KilaparaLicencingServerInstaller : System.Configuration.Install.Installer
	{
		private ServiceInstaller m_serviceInstaller = null;
		private ServiceProcessInstaller m_processInstaller = null;

		public KilaparaLicencingServerInstaller()
		{
			m_serviceInstaller = new ServiceInstaller();
			m_processInstaller = new ServiceProcessInstaller();

			m_serviceInstaller.AfterInstall += new System.Configuration.Install.InstallEventHandler(m_serviceInstaller_AfterInstall);

			m_processInstaller.Account = System.ServiceProcess.ServiceAccount.LocalSystem; 
			m_processInstaller.Password = null;
			m_processInstaller.Username = null;
			
			m_serviceInstaller.ServiceName = "Server Test";
			m_serviceInstaller.DisplayName = "Server Test";
			m_serviceInstaller.StartType = ServiceStartMode.Manual;

			Installers.Add(m_serviceInstaller);
			Installers.Add(m_processInstaller);			
		}		

		private void m_serviceInstaller_AfterInstall(object sender, System.Configuration.Install.InstallEventArgs e)
		{
			// turn on "Interact with desktop"
			ConnectionOptions coOptions = new ConnectionOptions();

			coOptions.Impersonation = ImpersonationLevel.Impersonate;

			ManagementScope mgmtScope = new System.Management.ManagementScope(@"root\CIMV2", coOptions);

			mgmtScope.Connect();

			ManagementObject wmiService;

			wmiService = new ManagementObject("Win32_Service.Name='Server Test'");

			ManagementBaseObject InParam = wmiService.GetMethodParameters("Change");

			InParam["DesktopInteract"] = true;

			ManagementBaseObject OutParam = wmiService.InvokeMethod("Change", InParam, null);
		}
	}
}
