using System;
using System.Threading;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace TestServiceWithMessageLoop
{
	public class WindowsMessageLoopThread
	{
		private Thread _thread = null;
		private AutoResetEvent _startedEvent = new AutoResetEvent(false);
		private Form1 _form = null;

		public WindowsMessageLoopThread()
		{
			_thread = new Thread(new ThreadStart(ThreadFunction));
			_thread.Start();
			_startedEvent.WaitOne();
		}

		public void Stop()
		{
			if (_form != null)
			{
				_form.Invoke(new MethodInvoker(_form.Close));			
				_form = null;
			}

			if (_thread != null)
			{
				_thread.Join();
				_thread = null;
			}
		}

		private void ThreadFunction()
		{
			try
			{
				_startedEvent.Set();

				_form = new Form1();
				System.Windows.Forms.Application.Run(_form);
			}
			catch (Exception)
			{
				// always ensure that the thread finishes
			}
		}
	}
}
